/*
 * File: sar.h
 * date: July 1998
 * Author: Yukio Hashimoto
   Thanks to Marc Greis (greis@cs.uni-bonn.de)
 * Modified by Nguyen Huu Thanh (thanh@informatik.unibw-muenchen.de)
 * date: June 29 1999
 */


#ifndef ns_sar_h
#define ns_sar_h

#include "agent.h"
#include "tclcl.h"
#include "packet.h"
#include "ip.h"


class SarAgent;

class Sar_Timer : public TimerHandler {
public:
	Sar_Timer(SarAgent *a) : TimerHandler() { a_ = a; }
	virtual void expire(Event *e);
protected:
	SarAgent *a_;

	
};



struct hdr_sar {
  char ret;
  double send_time;
  int total_cell_num;
  int cell_num;
  int pkt_num; 
  int pkt_size;
  struct hdr_ip IP;
  int seqno_;
  packet_t packet_type_; // needed for storing the original packet type
  int& seqno() {
		return (seqno_);
	}
};


class SarAgent : public Agent {
 public:
  SarAgent();
  int command(int argc, const char*const* argv);
  void recv(Packet*, Handler*);
  void timeout(int);
 protected:
  Sar_Timer sar_timer_;
  int off_sar_;
  NsObject* dst;
  int off_rtp_;
  int off_tcp_;
  int finish_seg;
};



static class SarHeaderClass : public PacketHeaderClass {
public:
  SarHeaderClass() : PacketHeaderClass("PacketHeader/Sar", 
					sizeof(hdr_sar)) {}
} class_sarhdr;


#endif
